<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
			text-align: left;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Database Transactions</h1>

		<p>CarbonPHP's database classes allow you to use <b>transactions</b> with databases that support transaction
		safe table types.  In MySQL, you will need to be running InnoDB or BDB table types instead of the common
		MyISAM/.  Most other database platforms support transactions natively.</p>

		<p>If you do not have experience with database transactions we recommend you find a resource to learn about
		them for your database platform.  This page assume you have previous experience with transactions.</p>
	</div>

	<div class="content">
		<h1>Transacations in CarbonPHP</h1>

		<p>CarbonPHP uses an approach similar to that of the ADODB class for transactions.  This approach simplifies
		the process of running transactions.  In most cases all that is needed are two lines of code.</p>

		<p>Usually transactions require a fair amount of code to implement since they demand that you keep track of
		your queries and determine whether to commit or rollback based on success or failure of the query.</p>
	</div>

	<div class="content">
		<h1>Running a Transaction</h1>

		<p>To run a query using a transaction you will need to use the <b>trans_start()</b> and
		<b>trans_complete()</b> methods.</p>

		<div class="example">
			<b>$this->db->trans_start();</b><br />
			$this->db->query('SOME QUERY');<br />
			$this->db->query('ANOTHER QUERY');<br />
			<b>$this->db->trans_complete();</b>
		</div>

		<p>You are allowed to run any amount of queries between the start and complete methods.  They will be committed
		or rolled back depending on success or failure.</p>
	</div>

	<div class="content">
		<h1>Managing Errors</h1>

		<p>If you have error reporting enabled in the <b>application/config/config.php</b> file you will see a
		standard error message if your commit was unsuccessful.  If debugging is enabled you can manage your own
		errors.</p>

		<div class="example">
			$this->db->trans_start();<br />
			$this->db->query('SOME QUERY');<br />
			$this->db->query('ANOTHER QUERY');<br />
			$this->db->trans_complete();<br />
			<br />
			if ($this->db->trans_status() === false)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;// Generate an error message...<br />
			&#125;
		</div>
	</div>

	<div class="content">
		<h1>Enabling Transactions</h1>

		<p>Transactions are enabled automatically the moment you call the <b>trans_start()</b> method.  If you wish
		to disabled transactions you can do so by calling the <b>trans_off()</b> method.</p>

		<div class="example">
			$this->db->trans_off();<br />
			<br />
			$this->db->trans_start();<br />
			$this->db->query('SOME QUERY');<br />
			$this->db->query('ANOTHER QUERY');<br />
			$this->db->trans_complete();
		</div>

		<p>When transcations are disabled your queries will be committed, just as they are when running queries
		without transactions.</p>
	</div>

	<div class="content">
		<h1>Test Mode</h1>

		<p>You can optionally put the transaction system into 'test mode' which will cause your queries to be rolled
		back, even if the queries produce a successful result.</p>

		<div class="example">
			$this->db->trans_start(<b>true</b>);<br />
			$this->db->query('SOME QUERY');<br />
			$this->db->trans_complete();<br />
		</div>
	</div>

	<div class="content">
		<h1>Manually Running a Transaction</h1>

		<p>If you wish to manually run a transaction you can do so like the following example.</p>

		<div class="example">
			<b>$this->db->trans_begin();</b><br />
			<br />
			$this->db->query('SOME QUERY');<br />
			$this->db->query('ANOTHER QUERY');<br />
			<br />
			if ($this->db->trans_status() === false)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;$this->db->trans_rollback();<br />
			&#125;<br />
			else<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;$this->db->trans_commit();<br />
			&#125;
		</div>

		<p>You should remember to use <b>trans_begin()</b> when running manual transactions instead of
		<b>trans_start()</b>.</p>
	</div>
</body>

</html>
